function [output_img] = myBilinearInterpolation(im)
%MYBILINEARINTERPOLATION Summary of this function goes here
%   Detailed explanation goes here

img = im2double(im);
% img = im2double(uint8([255, 50; 150, 130]));
[m,n] = size(img);
o_m = 3*m-2; % output image rows
o_n = 2*n-1; % output image cols

s_r = m / o_m;
s_c = n / o_n;

output_img = zeros(o_m, o_n);

for i = 1:o_m
    for j = 1:o_n
        r_f = i * s_r;
        c_f = j * s_c;
        
        if (r_f < 1)
            r_f = 1;
        end
        if (r_f >= m)
            r_f = m-1;
        end
        if (c_f < 1)
            c_f = 1;
        end
        if (c_f >= n)
            c_f = n-1;
        end
            
        [r,c] = deal(floor(r_f), floor(c_f));
        
        delta_r = r_f - r;
        delta_c = c_f - c;
        
        output_img(i,j) = img(r,c) * (1-delta_r) * (1-delta_c) ...
            + img(r+1,c) * delta_r * (1-delta_c) ...
            + img(r,c+1) * (1-delta_r) * delta_c ...
            + img(r+1,c+1) * delta_r * delta_c;
        
    end
end

end
