function [output_img] = myNearestNeighborInterpolation(im)
%MYNEARESTNEIGHBORINTERPOLATION Summary of this function goes here
%   Detailed explanation goes here
img = im2double(im);

[m,n] = size(img);
o_m = 3*m-2; % output image rows
o_n = 2*n-1; % output image cols

s_r = m / o_m;
s_c = n / o_n;

output_img = zeros(o_m, o_n);

for i = 1:o_m
    for j = 1:o_n
        r_f = i * s_r;
        c_f = j * s_c;
        
        if (r_f < 1)
            r_f = 1;
        end
        if (r_f > m-1)
            r_f = m-1;
        end
        if (c_f < 1)
            c_f = 1;
        end
        if (c_f > n-1)
            c_f = n-1;
        end
            
        [r,c] = deal(round(r_f), round(c_f));
        
        output_img(i,j) = img(r,c);
        
    end
end       
end

