function [output_im] = myAHE(im, m)
%MYAHE Summary of this function goes here
%   Detailed explanation goes here
im = uint16(im);

im = im + 1;
output_im = zeros(size(im));

for channel=1:size(im,3)
    output_im(:,:,channel) = nlfilter(im(:,:,channel), [m,m], @ahe);
end

output_im = uint8(output_im);
% figure;
% imshow(uint8(im-1));
% 
% figure;
% imshow(uint8(output_im));
end

function [intensity] = ahe(block)
m = size(block, 1);
x = block(ceil(m/2), ceil(m/2)) - 1;

block = block(block > 0);
block_vector = block(:) - 1;

freq = imhist(uint8(block_vector), 256);
pn = freq / size(block_vector, 1);
cdf = cumsum(pn);

intensity = floor(255 * cdf(x+1));
end

