function [output_im] = myHM()
%MYHM Summary of this function goes here
%   Detailed explanation goes here

global cum_im_hist cum_im_ref_hist lookup_table;
im = imread('../data/retina.png');
im_mask = imread('../data/retinaMask.png');
im_ref = imread('../data/retinaRef.png');
im_ref_mask = imread('../data/retinaRefMask.png');

output_im = zeros(size(im)); % output image

for channel=1:size(im, 3)
    lookup_table = zeros(1, 256);
    lookup_table(:) = -1;

    im_channel = im(:,:,channel);
    im_hist = imhist(im_channel(im_mask), 256);
    cum_im_hist = cumsum(im_hist);
    
    im_ref_channel = im_ref(:,:,channel);
    im_ref_hist = imhist(im_ref_channel(im_ref_mask), 256);
    cum_im_ref_hist = cumsum(im_ref_hist);
        
    for i=1:size(output_im, 1)
        for j=1:size(output_im, 2)
            output_im(i,j,channel) = hist_match(im_channel(i,j) + 1);
        end
    end
    
end

output_im = uint8(output_im);
% figure;
% imshow(im);
% 
% figure;
% imshow(uint8(output_im));

end

function [idx] = hist_match(x)
global cum_im_hist cum_im_ref_hist lookup_table;

if (lookup_table(x) ~= -1)
    idx = lookup_table(x);
else
    [v,idx] = min(abs(cum_im_hist(x)-cum_im_ref_hist));
    lookup_table(x) = idx;
end
    
end
